public class LStack<T> implements IStack<T>
{
    private Node<T> top;
    private int size;
    public LStack()
    {
        top = null;
        size = 0;
    }
    public boolean isEmpty()
    {
        return top == null;
    }
    public void push(T newItem)
    {
        top = new Node<T>(newItem, top);
        size++;
    }
    public T pop()
    {
        if(isEmpty())
        {   
            throw new EmptyStackException();
        }
        T out = top.getDatum();
        top = top.getNext();
        size--;
        return out;
    }
    public T peek()
    {
        return top.getDatum();
    }
    public int size()
    {
        return size;
    }
    @Override
    public String toString()
    {
        if(isEmpty())
        {
            return "[]";
        }
        StringBuffer sb = new StringBuffer();
        sb.append("[");
        LStack<T> shadow = new LStack<>();
        for(int k = 0; k < size; k++)
        {
            shadow.push(pop());
        }
        Node<T> nav = shadow.top;
        for(int k = 0; k < size - 1; k++, nav = nav.getNext())
        {
            sb.append(String.format("%s, ", nav.getDatum()));
        }
        sb.append(String.format("%s]", nav.getDatum()));
        return sb.toString();

    }
    public static void main(String[] args)
    {
        AStack<String> s = new AStack<>();
        s.push("cows");
        s.push("sheep");
        for(int k = 0; k < 100; k++)
        {
            s.push("" + k);
        }
        /*while(!s.isEmpty())
        {
            s.pop();
        }*/
        System.out.println(s);
    }
}
class Node<T>
{
    private final T datum;
    private Node<T> next;
    public Node(T datum, Node<T> next)
    {
        this.datum = datum;
        this.next = next;
    }
    public T getDatum()
    {
        return datum;
    }
    public Node<T> getNext()
    {
        return next;
    }
}
